#ifdef NON_ANSI
NODE  * ged_apply_tree();
NODE  * ged_ask();
NODE  * ged_ask_partial();
NODE  * ged_ask_string();
NODE  * ged_ask_xref();
long    ged_base30_to_long();
void    ged_buffered_to_file();
void    ged_clip_word();
NODE  * ged_connect_child();
NODE  * ged_connect_sibling();
NODE  * ged_copy_node();
NODE  * ged_copy_tree();
NODE  * ged_clone_node();
NODE  * ged_clone_tree();
NODE  * ged_duplicate_tree();
int     ged_error();
int     ged_find_level();
byte  * ged_find_line();
int     ged_fprintf_line();
NODE  * ged_get_child();
NODE  * ged_get_last_sibling();
byte  * ged_get_line();
NODE  * ged_get_next_level();
NODE  * ged_get_next_node();
NODE  * ged_get_parent();
NODE  * ged_get_previous_node();
NODE  * ged_get_previous_sibling();
NODE  * ged_get_sibling();
byte  * ged_get_tag();
int     ged_get_tree_size();
byte  * ged_get_value();
byte  * ged_get_value_raw();
byte  * ged_get_xref();
NODE  * ged_hunt_tags();
int     ged_imatch();
int     ged_indent_line();
int     ged_inherits();
NODE  * ged_insert_subtree();
byte  * ged_long_to_base30();
NODE  * ged_make_path();
int     ged_match();
int     ged_match_tags();
int     ged_match_xrefs();
NODE *  ged_move_to_child();
NODE *  ged_move_to_sibling();
int     ged_output_level();
unsigned long ged_pool_size();
byte  * ged_prev_word();
int     ged_print_indented();
int     ged_print_levels();
void    ged_promote();
NODE  * ged_prune_tree();
int     ged_read_level();
void    ged_read_line();
byte  * ged_read_rec();
NODE  * ged_read_nodetree();
byte  * ged_read_partial_rec();
NODE  * ged_read_partial_tree();
NODE  * ged_read_tree();
NODE  * ged_remove_children();
void    ged_remove_node();
NODE  * ged_remove_siblings();
NODE  * ged_remove_subtree();
void    ged_set_error_handler();
byte  * ged_set_line();
byte  * ged_set_tag();
byte  * ged_set_value();
byte  * ged_set_xref();
byte  * ged_skip_word();
int     ged_sprintf_line();
NODE  * ged_to_tree();
void    ged_tree_to_file();
byte  * ged_tree_to_ged();
/**/
#else

#ifdef __cplusplus
extern "C" {
#endif

NODE  * ged_apply_tree(NODE *, int, int, int (*)(int, NODE *, void *, void *),
               void *, void *);
NODE  * ged_ask(NODE *, byte *, int);
NODE  * ged_ask_partial(NODE *, byte *, int);
NODE  * ged_ask_string(NODE *, byte *, int);
NODE  * ged_ask_xref(NODE *, byte *);
long    ged_base30_to_long(byte *);
void    ged_buffered_to_file(NODE *, FILE *, int);
void    ged_clip_word(byte *);
NODE  * ged_connect_child(NODE *, NODE *, int);
NODE  * ged_connect_sibling(NODE *, NODE *, int);
NODE  * ged_copy_node(byte *, NODE *, NODE *);
NODE  * ged_copy_tree(NODE *);
NODE  * ged_clone_node(byte *, NODE *, NODE *);
NODE  * ged_clone_tree(NODE *);
NODE  * ged_duplicate_tree(NODE *, NODE *(*)(byte *, NODE *, NODE *));
int     ged_error(int, NODE *);
int     ged_find_level(byte **);
byte  * ged_find_line(byte **, int *);
int     ged_fprintf_line(int, NODE *, void *, void *);
NODE  * ged_get_child(NODE *);
NODE  * ged_get_last_sibling(NODE *);
byte  * ged_get_line(NODE *);
NODE  * ged_get_next_level(NODE *, int *);
NODE  * ged_get_next_node(NODE *);
NODE  * ged_get_parent(NODE *);
NODE  * ged_get_previous_node(NODE *);
NODE  * ged_get_previous_sibling(NODE *);
NODE  * ged_get_sibling(NODE *);
byte  * ged_get_tag(NODE *);
int     ged_get_tree_size(NODE *);
byte  * ged_get_value(NODE *);
byte  * ged_get_value_raw(NODE *);
byte  * ged_get_xref(NODE *);
NODE  * ged_hunt_tags(NODE *, byte *, int *);
int     ged_imatch(byte *, byte *);
int     ged_indent_line(int, NODE *, void *, void *);
int     ged_inherits(NODE *, byte *);
NODE  * ged_insert_subtree(NODE *, NODE *);
byte  * ged_long_to_base30(long, byte *, int);
NODE  * ged_make_path(byte *);
int     ged_match(byte *, byte *);
int     ged_match_tags(NODE *, NODE *);
int     ged_match_xrefs(int, NODE *, void *, void *);
NODE *  ged_move_to_child(NODE *, NODE *, int);
NODE *  ged_move_to_sibling(NODE *, NODE *, int);
int     ged_output_level(int, NODE *, void *, void *);
unsigned long ged_pool_size(void);
byte  * ged_prev_word(byte *, byte *);
int     ged_print_indented(NODE *, FILE *);
int     ged_print_levels(NODE *, FILE *);
void    ged_promote(NODE *);
NODE  * ged_prune_tree(NODE *, int);
int     ged_read_level(FILE *, byte **, long *, short, short *, int *);
void    ged_read_line(FILE *, byte **, long *, short *, int *);
byte  * ged_read_rec(FILE *, byte *, long, short *);
NODE  * ged_read_nodetree(FILE *, short *);
byte  * ged_read_partial_rec(FILE *, byte *, long, short *, int, byte *);
NODE  * ged_read_partial_tree(FILE *, byte *, unsigned long, short *, int, byte *);
NODE  * ged_read_tree(FILE *, byte *, unsigned long, short *);
NODE  * ged_remove_children(NODE *);
void    ged_remove_node(NODE *);
NODE  * ged_remove_siblings(NODE *);
NODE  * ged_remove_subtree(NODE *); 
void    ged_set_error_handler(int (*error_handler)(int, NODE *));
byte  * ged_set_line(NODE *, byte *);
byte  * ged_set_tag(NODE *, byte *);
byte  * ged_set_value(NODE *, byte *);
byte  * ged_set_xref(NODE *, byte *);
byte  * ged_skip_word(byte *);
int     ged_sprintf_line(int, NODE *, void *, void *);
NODE  * ged_to_tree(byte **, int *);
void    ged_tree_to_file(NODE *, FILE *, unsigned);
byte  * ged_tree_to_ged(NODE *, byte *, unsigned, unsigned);

#ifdef __cplusplus
}
#endif

#endif
/**/
#define GED_COPY_TREE(tree)     (ged_duplicate_tree(tree, ged_copy_node))
#define GED_CLONE_TREE(tree)    (ged_duplicate_tree(tree, ged_clone_node))
#define GED_GET_CHILD(node)    (node ? node->child : NULL)
#define GED_GET_PARENT(node)    (node ? node->parent : NULL)

#define MAX_CROSSREF_LEN 22
#define MIN_CROSSREF_LEN 3
#define MAX_ESCAPE_LEN 23
#define MIN_ESCAPE_LEN 5
#define MAX_TAG_LEN 31
#define MIN_TAG_LEN 1
#define MAX_LINE_LEN 255

#define END_OF_FILE     0
#define REC_TOO_LONG    1
#define MORE_RECORDS    2
#define LAST_RECORD     3
#define MISSING_LEVEL   4
#define MORE            1
#define LAST            2
