/***********************************************************************
*$Header:   J:/aim/gedcom/gedlib/vcs/gedaskst.c_v   1.8   21 Nov 1995 07:55:38   ODJENSEN  $
*
*$config$="/K! /L/* /R* /Mgedaskst.c"
*
*   FILE NAME: GEDASKST.C           
*
*   DESCRIPTION:
*       This file contains functions which find context within a record
*
*   ROUTINES:
*       NODE * ged_ask_string(NODE * obj, byte * msg, int nth)
*
*   MODIFICATION HISTORY:
*
*$Log:   J:/aim/gedcom/gedlib/vcs/gedaskst.c_v  $
 * 
 *    Rev 1.8   21 Nov 1995 07:55:38   ODJENSEN
 * Changed to new style declarator.
 * 
 *    Rev 1.7   30 Jun 1994 09:23:52   ODJENSEN
 * Added line #include "gedcom.h"
 * 
 *    Rev 1.6   30 Jun 1994 09:15:34   ODJENSEN
 * Added stub function back from ged_ask_string().  All it does is call
 * ged_ask().
 * 
 *    Rev 1.5   03 Jun 1993 08:36:40   fhdodj
 * Moved all of these functions to ged_ask, and removed the _string from
 * their name.
 * 
 *    Rev 1.4   26 Mar 1992 10:29:44   fhdodj
 * Replaced tmpPos with ged_skip_word in ged_hunt_tags.
 * 
 *    Rev 1.3   25 Mar 1992 15:43:40   fhdodj
 * Added function ged_ask_partial_string().
 * 
 *    Rev 1.2   21 Oct 1991 09:04:58   fhdodj
 * Changed char to byte.
 * 
 *    Rev 1.1   28 Jun 1991 11:39:52   fhdkrf
 * Added keywords for PolyDoc
 * 
 *    Rev 1.0   17 Jun 1991 12:23:20   odj
 * Initial revision.
***********************************************************************/

#include "gedcom.h"

/********************************************************************
*
*        NAME: ged_ask_string
*
*        DESCRIPTION:
*            This function calls ged_ask.
*
*        RETURN VALUE:
*            Returns the return value from ged_ask.
*
*        CALLS: ged_ask
*
********************************************************************/
NODE * ged_ask_string(NODE *obj,  /* The tree to will follow path msg in */
                      byte *msg,  /* The path to follow */
                      int   nth)  /* Which occurance to return */
    {
        return ged_ask(obj, msg, nth);
    }
